package com.nokia.warninginterfact.config;

import com.nokia.warninginterfact.config.service.ISpringScheduledCronService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;
import org.springframework.scheduling.support.CronTrigger;

import java.util.Date;
import java.util.concurrent.Executor;
import java.util.concurrent.Executors;

@Configuration
public class ScheduledConfig implements SchedulingConfigurer {
    @Autowired
    private ApplicationContext context;
    @Autowired
    private ISpringScheduledCronService cronSerivce;

    //    @Autowired
//    private ISpringScheduledOracelCronService cronService;
    @Override
    public void configureTasks(ScheduledTaskRegistrar taskRegistrar) {
        System.out.println("执行任务时间：" + new Date());
        try {
            cronSerivce.getHttpHistory();
        } catch (Exception e) {
            e.printStackTrace();
        }
        taskRegistrar.setScheduler(taskExecutor());
        taskRegistrar.addTriggerTask(() -> {
                    try {
                        cronSerivce.getHttpSave();
                        cronSerivce.getHttpUpdate();
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                    System.out.println("执行任务时间：" + new Date());
                },
                triggerContext -> {
                    String cronExpression = "0 */5 * * * ?";
                    return new CronTrigger(cronExpression).nextExecutionTime(triggerContext);
                }
        );

    }

    @Bean
    public Executor taskExecutor() {
        return Executors.newScheduledThreadPool(10);
    }
}
