package com.nokia.warninginterfact.config.service.impl;

import com.alibaba.fastjson.JSON;
import com.nokia.warninginterfact.config.entity.MessageCfg;
import com.nokia.warninginterfact.config.entity.ResultInfo;
import com.nokia.warninginterfact.config.entity.ResultMap;
import com.nokia.warninginterfact.config.mapper.ResultMapDao;
import com.nokia.warninginterfact.config.mapper.ResultMapOracelDao;
import com.nokia.warninginterfact.config.service.ISpringScheduledCronService;
import com.nokia.warninginterfact.util.ExportUtils;
import com.hl.opnc.AbilityResponse;
import com.hl.opnc.ResponseBody;
import com.hl.opnc.invoke.AbilityInvokeManager;
import com.hl.opnc.invoke.InvokeManager;
import com.nokia.warninginterfact.util.UtilInfo;
import net.sf.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

@Service
@Transactional
public class SpringScheduledCronServiceImpl   implements ISpringScheduledCronService {
    private static final Logger log = LoggerFactory.getLogger(SpringScheduledCronServiceImpl.class);
    private final static DateFormat FORMAT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//    @Value("${databasename}")
//    private String databasename;
    @Value("${httpurl}")
    private String methodUrl;
    @Value("${appId}")
    private String appId;
    @Value("${secret}")
    private String secret;

    @Value("${updatetime}")
    private String updatetime;
    @Value("${updatenum}")
    private int updatenum;
    @Value("${isupdate}")
    private boolean isupdate;
    public static MessageCfg getBody() {
        String startTime =  UtilInfo.addDateMinut(new Date(),-35);
        String endTime=  UtilInfo.addDateMinut(new Date(),-30);
        MessageCfg cfg = new MessageCfg();
        cfg.setStartTime(startTime);
        cfg.setEndTime(endTime);
        cfg.setResultDataType(1);   //csv2
        cfg.setResultFieldType(1);
        cfg.setPageNum(0);
        List provincelist = new ArrayList();
        provincelist.add("河北省");
        cfg.setProvince(provincelist);
        List networklist = new ArrayList();
        networklist.add("104");
        cfg.setNetworkType(networklist);
        cfg.setPageSize(10000);
        System.out.println(JSON.toJSONString(cfg));
        return cfg;
    }
    public static MessageCfg getnextBody(MessageCfg cfg,int page) {
        cfg.setPageNum(page);
        System.out.println("执行页数更新"+JSON.toJSONString(cfg));
        return cfg;
    }
    @Override
    public void getHttpSave() throws Exception {
        System.out.println("执行入库=========================================================================");
        InvokeManager manager = new AbilityInvokeManager(appId,secret);
        AbilityResponse response = manager.post(methodUrl,null,JSON.toJSONString(getBody()));
        ResponseBody resObj=response.getRespObj();
        System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
        String  body=(String)resObj.getUNI_NET_BODY();
        body = body.replace("null","\"\"");
        ResultInfo info=JSON.parseObject(body,ResultInfo.class);
        String data = info.getTotal()+"";
        System.out.println("返回数据="+data);
        if(data.equalsIgnoreCase("0")){
            System.out.println("返回数据0条");
        }else {
            List<ResultMap> result = info.getResult();
            String[] header = null;

            if (result.size() > 0) {
                header = UtilInfo.getheader(result.get(0));
            }
            ResultMapDao.InsertData(result);
            ExportUtils.exportCsvFile(header, result);
        }
        response.close();
//        System.out.println("返回数据="+data);
        System.out.println("执行结束");
    }

    @Override
    public void getHttpUpdate() throws Exception {
        System.out.println("执行入库========================================================================="+updatenum+"="+updatetime);
        InvokeManager manager = new AbilityInvokeManager("0f9bf497549343e68ca36b4caffbc8c4","087b1ceb698140cd8c65543f5ace0490");
        MessageCfg cfg=UtilInfo.gethistoryBody();
        AbilityResponse response = manager.post(methodUrl,null,JSON.toJSONString(cfg));
        ResponseBody resObj=response.getRespObj();
        System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
        String  body=(String)resObj.getUNI_NET_BODY();
        body = body.replace("null","\"\"");
        ResultInfo info=JSON.parseObject(body,ResultInfo.class);
        int rows =info.getTotal();// jsonObject.getInt("total");
        System.out.println("返回数据"+rows+"条");
        if(rows==0){
            System.out.println("返回数据0条");
        }else {
            List<ResultMap> result = info.getResult();
            ResultMapDao.InsertData(result);
        }
        response.close();
//        System.out.println("返回数据"+rows+"条");
        System.out.println("执行结束");
    }
    @Override
    public void getHttpHistory() throws Exception {
        if(isupdate) {
            int rownum = 1;
//        String date="2021-05-27 11:30:00";
            connectBy(rownum, updatetime);
        }else{
            System.out.println("不补入");
        }

    }
    public  void connectBy(int rownum,String date) throws Exception {
        if(rownum<=updatenum) { //相当于connect by后面的条件
            rownum++;
            String startTime = UtilInfo.formatDate(date);
            String endTime= UtilInfo.add10Min(startTime);
            MessageCfg cfg = new MessageCfg();
            cfg.setStartTime(startTime);
            cfg.setEndTime(endTime);
            cfg.setResultDataType(1);   //csv2
            cfg.setResultFieldType(1);
            cfg.setPageNum(0);
            List provincelist = new ArrayList();
            provincelist.add("河北省");
            cfg.setProvince(provincelist);
            List networklist = new ArrayList();
            networklist.add("104");
            cfg.setNetworkType(networklist);
            cfg.setPageSize(10000);
            System.out.println(JSON.toJSONString(cfg));
            InvokeManager manager = new AbilityInvokeManager("0f9bf497549343e68ca36b4caffbc8c4","087b1ceb698140cd8c65543f5ace0490");
            AbilityResponse response = manager.post(methodUrl,null,JSON.toJSONString(cfg));
            ResponseBody resObj=response.getRespObj();
            System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
            String  body=(String)resObj.getUNI_NET_BODY();
//            System.out.println(body);
            body = body.replace("null","\"\"");
            ResultInfo info=JSON.parseObject(body,ResultInfo.class);
            String data = info.getTotal()+"";//jsonObject.getString("total");
            System.out.println(" 返回总数="+data);
            if(data.equalsIgnoreCase("0")){
                System.out.println("返回数据0条");
            }else {
                List<ResultMap> result = info.getResult();
                ResultMapDao.InsertData(result);
//                String[] header = null;
                response.close();
//                ResultMapOracelDao.InsertData(result);
            }
            System.out.println(" 返回总数="+data);
            System.out.println("执行结束");
            Thread.sleep(1000);
            connectBy(rownum,endTime);   //执行完select子句以后再次执行connect by
        }
    }
    public static String add5Min(String date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            Date d = sdf.parse(date);
            Calendar cal = Calendar.getInstance();
            cal.setTime(d);
            cal.add(Calendar.MINUTE, 5);
            date = sdf.format(cal.getTime());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date;
    }
}
