package com.nokia.warninginterfact.config.service.impl;

import com.alibaba.fastjson.JSON;
import com.hl.opnc.AbilityResponse;
import com.hl.opnc.ResponseBody;
import com.hl.opnc.invoke.AbilityInvokeManager;
import com.hl.opnc.invoke.InvokeManager;
import com.nokia.warninginterfact.config.entity.MessageCfg;
import com.nokia.warninginterfact.config.entity.ResultInfo;
import com.nokia.warninginterfact.config.entity.ResultMap;
import com.nokia.warninginterfact.config.mapper.ResultMapOracelDao;
import com.nokia.warninginterfact.config.service.ISpringScheduledOracelCronService;
import com.nokia.warninginterfact.util.ExportUtils;
import com.nokia.warninginterfact.util.UtilInfo;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.*;
@Service
@Transactional
public class SpringScheduledOracelCronServiceImpl implements ISpringScheduledOracelCronService {
    @Value("${oracehttplurl}")
    private String methodUrl;
    @Value("${appId}")
    private String appId;
    @Value("${secret}")
    private String secret;

    @Value("${updatetime}")
    private String updatetime;
    @Value("${updatenum}")
    private int updatenum;
    @Value("${isupdate}")
    private boolean isupdate;
    private final static DateFormat FORMAT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    public static MessageCfg getBody() {
        String startTime = UtilInfo.addDateMinut(new Date(),-35);
        String endTime=UtilInfo.addDateMinut(new Date(),-30);
        MessageCfg cfg = new MessageCfg();
        cfg.setStartTime(startTime);
        cfg.setEndTime(endTime);
        cfg.setResultDataType(1);   //csv2
        cfg.setResultFieldType(1);
        cfg.setPageNum(0);
        List provincelist = new ArrayList();
        provincelist.add("河北省");
        cfg.setProvince(provincelist);
        List networklist = new ArrayList();
        networklist.add("104");
        cfg.setNetworkType(networklist);
        cfg.setPageSize(10000);
        System.out.println(JSON.toJSONString(cfg));
        return cfg;
    }
    /**
     * 入库并保存到csv
     *
     * @throws Exception
     */
    @Override
    public void getHttpSave() throws Exception {

        System.out.println("执行入库=========================================================================");
        InvokeManager manager = new AbilityInvokeManager(appId,secret);
        AbilityResponse response = manager.post(methodUrl,null, JSON.toJSONString(getBody()));
        ResponseBody resObj=response.getRespObj();
        System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
        String  body=(String)resObj.getUNI_NET_BODY();
//        System.out.println(body);
        body = body.replace("null","\"\"");
        ResultInfo info=JSON.parseObject(body,ResultInfo.class);
        String data =info.getTotal()+"";
        if(data.equalsIgnoreCase("0")){
            System.out.println("返回数据0条");
        }else {
            List<ResultMap> result = info.getResult();
            String[] header = null;
            response.close();
            if (result.size() > 0) {
                header = UtilInfo.getheader(result.get(0));
            }
            ResultMapOracelDao.InsertData(result);
            ExportUtils.exportCsvFile(header, result);
        }
        System.out.println("返回数据="+data);
        System.out.println("执行结束");
    }
    @Override
    public void getHttpUpdate() throws Exception {
        System.out.println("执行入库=========================================================================");
        MessageCfg cfg=UtilInfo.gethistoryBody();
        InvokeManager manager = new AbilityInvokeManager("0f9bf497549343e68ca36b4caffbc8c4","087b1ceb698140cd8c65543f5ace0490");
        AbilityResponse response = manager.post(methodUrl,null,JSON.toJSONString(cfg));
        ResponseBody resObj=response.getRespObj();
        System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
        String  body=(String)resObj.getUNI_NET_BODY();
        response.close();
//        System.out.println(body);
        body = body.replace("null","\"\"");
        ResultInfo info=JSON.parseObject(body,ResultInfo.class);
        int rows =info.getTotal();// jsonObject.getInt("total");
        int pageSize=cfg.getPageSize();
        //页数
        int pageSum=(rows-1)/pageSize;
        System.out.println("返回数据"+rows+"条");
        if(rows==0){
            System.out.println("返回数据0条");
        }else {
            List<ResultMap> result = info.getResult();
            ResultMapOracelDao.InsertData(result);
            response.close();
            for(int i=1;i<pageSum;i++){
                getPageData(cfg,i);
                Thread.sleep(3000);
            }
        }
        System.out.println("返回数据"+rows+"条");
        System.out.println("执行结束");
    }
    public void getPageData(MessageCfg cfg, int page) throws Exception {

        InvokeManager manager = new AbilityInvokeManager("0f9bf497549343e68ca36b4caffbc8c4","087b1ceb698140cd8c65543f5ace0490");
        AbilityResponse response = manager.post(methodUrl,null,JSON.toJSONString(UtilInfo.getnextBody(cfg,page)));
        ResponseBody resObj=response.getRespObj();
        System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
        String  body=(String)resObj.getUNI_NET_BODY();
        body = body.replace("null","\"\"");
//        System.out.println(body);
        ResultInfo info=JSON.parseObject(body,ResultInfo.class);
        String data = info.getTotal()+"";//jsonObject.getString("total");
//        System.out.println("返回数据"+data+"条");
        if(data.equalsIgnoreCase("0")){
            System.out.println("返回数据0条");
        }else {
            List<ResultMap> result = info.getResult();
            ResultMapOracelDao.InsertData(result);
            String[] header = null;
            response.close();
//            if (result.size() > 0) {
//                header = UtilInfo.getheader(result.get(0));
//            }
            ResultMapOracelDao.InsertData(result);
//            ExportUtils.exportCsvFile(header, result);
        }
        System.out.println("数据页数="+page+" 返回总数="+data);
        System.out.println("执行结束");
    }

    @Override
    public void getHttpHistory() throws Exception {
//        Date s=new Date();
//        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd HH:00:00");
//        String date = sdf.format(s);
//        String date="2021-05-27 09:00:00";
//        int rownum=1;
//        connectBy(rownum,date);
        if(isupdate) {
            int rownum = 1;
            connectBy(rownum, updatetime);
        }else{
            System.out.println("不补入数据");
        }

    }
    public  void connectBy(int rownum,String date) throws Exception {
        if(rownum< 20) { //相当于connect by后面的条件
            rownum++;
            String startTime = UtilInfo.formatDate(date);
            String endTime= UtilInfo.add10Min(startTime);
            MessageCfg cfg = new MessageCfg();
            cfg.setStartTime(startTime);
            cfg.setEndTime(endTime);
            cfg.setResultDataType(1);   //csv2
            cfg.setResultFieldType(1);
            cfg.setPageNum(0);
            List provincelist = new ArrayList();
            provincelist.add("河北省");
            cfg.setProvince(provincelist);
            List networklist = new ArrayList();
            networklist.add("104");
            cfg.setNetworkType(networklist);
            cfg.setPageSize(10000);
            System.out.println(JSON.toJSONString(cfg));
            InvokeManager manager = new AbilityInvokeManager("0f9bf497549343e68ca36b4caffbc8c4","087b1ceb698140cd8c65543f5ace0490");
            AbilityResponse response = manager.post(methodUrl,null,JSON.toJSONString(cfg));
            ResponseBody resObj=response.getRespObj();
            System.out.println("getUNI_NET_HEAD="+JSON.toJSONString(resObj.getUNI_NET_HEAD()));
            String  body=(String)resObj.getUNI_NET_BODY();
//            System.out.println(body);
            body = body.replace("null","\"\"");
            ResultInfo info=JSON.parseObject(body,ResultInfo.class);
            String data = info.getTotal()+"";//jsonObject.getString("total");
            if(data.equalsIgnoreCase("0")){
                System.out.println("返回数据0条");
            }else {
                List<ResultMap> result = info.getResult();
                ResultMapOracelDao.InsertData(result);
//                String[] header = null;
                response.close();
//                ResultMapOracelDao.InsertData(result);
            }
            System.out.println(" 返回总数="+data);
            System.out.println("执行结束");
            Thread.sleep(1000);
            connectBy(rownum,endTime);   //执行完select子句以后再次执行connect by
        }
    }
}
