package com.nokia.warninginterfact.util;

import com.nokia.warninginterfact.config.entity.ResultMap;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.csv.CSVFormat;
import org.apache.commons.csv.CSVPrinter;

import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;

public class ExportUtils {
    // public static String filePath = "C:\\Users\\lenovo\\Desktop\\sjz\\";
    // 备份文件的位置
    public static String filePath = "csv";
    //    public static  String filePath = File.separator+"data"+ File.separator+"20210517"+File.separator+"csv";
    public static String fileName = "resultMap";
    public static final String NEW_LINE_SEPARATOR = "\r\n";
    //    public static final String separator = "|"; // 分隔符
    public static char recordSeparator = ',';

    public static String exportCsvFile(Object[] header, List<ResultMap> dataList, String type) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMddHHmmss");
        //文件输出流
        String path = filePath + File.separator + fileName + type + sdf.format(new Date()) + ".csv";
        makeDir(filePath);
        Writer fileWriter = null;
        CSVPrinter csvFilePrinter = null;
        long start = System.currentTimeMillis();
        // 创建 CSVFormat
        CSVFormat csvFileFormat = CSVFormat.DEFAULT.withRecordSeparator(NEW_LINE_SEPARATOR).withDelimiter(recordSeparator);
        try {
            System.out.println("CSV文件创建开始");
            // 初始化FileWriter
            fileWriter = new BufferedWriter(
                    new OutputStreamWriter(
                            new FileOutputStream(path), "gbk"));
            // 初始化 CSVPrinter
            csvFilePrinter = new CSVPrinter(fileWriter, csvFileFormat);
            // 创建CSV文件头
            if (header != null && header.length > 0) {
                csvFilePrinter.printRecord(header);
//                    String arrString = Arrays.toString(header);
//                    System.out.println("header"+arrString);
            }
            // 遍历List写入CSV
            for (ResultMap dataRecord : dataList) {
                csvFilePrinter.printRecord(getValue(dataRecord, header));
            }


            long end = System.currentTimeMillis();

            System.out.println("CSV文件创建成功,用时" + (end - start) + "ms,文件输出路径:" + path);
            return path;
        } catch (Exception e) {
            System.out.println("CSV文件创建失败");
            e.printStackTrace();
        } finally {
            try {
                fileWriter.flush();
                fileWriter.close();
                csvFilePrinter.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return NEW_LINE_SEPARATOR;
    }

    /**
     * 创建文件目录
     *
     * @param outPath
     * @return void
     */
    public static void makeDir(String outPath) {
        File file = new File(outPath);
        if (!file.exists()) {
            file.mkdirs();
        }
    }

    /**
     * 读取文件
     *
     * @param fileName
     * @return
     */
    public static String readFileContent(String fileName) {
        File file = new File(fileName);
        BufferedReader reader = null;
        StringBuffer sbf = new StringBuffer();
        try {
            reader = new BufferedReader(new FileReader(file));
            String tempStr;
            while ((tempStr = reader.readLine()) != null) {
                sbf.append(tempStr);
            }
            reader.close();
            return sbf.toString();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e1) {
                    e1.printStackTrace();
                }
            }
        }
        return sbf.toString();
    }

    public static List<Object> getValue(ResultMap result, Object[] st) throws Exception {
        List<Object> list = new ArrayList<Object>();
        Map<String, Object> testmap = BeanUtils.describe(result);
        for (int i = st.length - 1; i >= 0; i--) {
            list.add(testmap.get(st[i]));
        }
        Collections.reverse(list);
        return list;
    }
}
