package com.nokia.warninginterfact.util;

import com.alibaba.fastjson.JSON;
import com.nokia.warninginterfact.config.entity.MessageCfg;
import com.nokia.warninginterfact.config.entity.ResultMap;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

public class UtilInfo {
    private final static DateFormat FORMAT = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    public static MessageCfg gethistoryBody() {
        String startTime = addDateMonth(new Date(),-1);
        String endTime= FORMAT.format(new Date());
//        String startTime = "2021-05-26 00:00:00";
//        String endTime="2021-05-26 23:59:59";
        MessageCfg cfg = new MessageCfg();
        cfg.setStartTime(startTime);
        cfg.setEndTime(endTime);
        cfg.setResultDataType(1);   //csv2
        cfg.setResultFieldType(1);
        cfg.setPageNum(0);
        List provincelist = new ArrayList();
        provincelist.add("河北省");
        cfg.setProvince(provincelist);
        List networklist = new ArrayList();
        networklist.add("104");

        List cancelTime = new ArrayList();
        cancelTime.add( addDateMinut(new Date(),-35));
        cancelTime.add( addDateMinut(new Date(),-30));
//
        cfg.setCancelTime(cancelTime);
        cfg.setNetworkType(networklist);
        cfg.setPageSize(10000);
        System.out.println(JSON.toJSONString(cfg));
        return cfg;
    }
    public static String[] getheader(ResultMap rs)  {
        String[] header= new String[]{"uniqueId","uniqueClearId","eventTime","cancelTime","status","projectStatus","vendorAlarmSerial","alarmTitle","vendorSeverity","vendorAlarmType","specificProblem","specificProblemID","equipmentClass","equipmentName","locateNeClass","locateNeName","locateNEDN","province","region","city","grid","area","vendor","specialty","siteId","roomId","towerSiteNo","proEquipmentStatus","projectName","projectNo","projectStartTime","projectEndTime","workSendStatus","workStatus","workNo","workArchivedTime","workDutyDep","workSendPerson","alarmLogicClass","alarmLogicSubClass","standardAlarmName","alarmSeverity","standardAlarmId","effectOnEquipment","effectOnBusiness","tacCode","tacId","alarmText"};
        return header;
    }
    public static String addDateMinut(Date date, int x){
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");// 24小时制
        //引号里面个格
        if (date == null)
            return "";
//        System.out.println("front:" + format.format(date)); //显示输入的日期
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);
        cal.add(Calendar.MINUTE, x);// 24小时制
        date = cal.getTime();
//        System.out.println("after:" + format.format(date));  //显示更新后的日期
        cal = null;
        return format.format(date);

    }
    public static String addDateMonth(Date date, int x){
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");// 24小时制
        //量day格式一致
        if (date == null)
            return "";
        System.out.println("front:" + format.format(date)); //显示输入的日期
        Calendar cal = Calendar.getInstance();
        cal.setTime(date);

        cal.add(Calendar.MONTH, x);// 24小时制
        date = cal.getTime();
        System.out.println("after:" + format.format(date));  //显示更新后的日期
        cal = null;
        return format.format(date);

    }
    public static MessageCfg getnextBody(MessageCfg cfg,int page) {
        cfg.setPageNum(page);
        System.out.println("执行页数更新"+JSON.toJSONString(cfg));
        return cfg;
    }
    public static String formatDate(String date) {
        SimpleDateFormat sdf=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            date= sdf.format(sdf.parse(date));
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date;
    }
    public static String add10Min(String date) {
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            Date d = sdf.parse(date);
            Calendar cal = Calendar.getInstance();
            cal.setTime(d);
            cal.add(Calendar.MINUTE, 10);
            date = sdf.format(cal.getTime());
        } catch (ParseException e) {
            e.printStackTrace();
        }
        return date;
    }
}
